<template>
  <v-dialog
    ref="addChiTieu"
    v-model="dialog"
    max-width="600px"
    persistent
  >
    <v-card>
      <v-form ref="form">
        <v-card-title class="text-left info pa-1">
          <h4
            class="pa-2"
            style="color: #ffffff"
          >
            Cập nhật trạng thái
          </h4>
          <v-icon
            right
            style="color: #ffffff"
            @click.native="dialog = false"
          >
            clear
          </v-icon>
        </v-card-title>

        <v-divider />

        <v-card-text>
          <v-container class="pt-0 pb-0 mb-0">
            <v-row>
              <v-col cols="5">
                <v-autocomplete
                  ref="spec"
                  v-model="chiTieuModel.ky_chi"
                  :items="lstKyChi"
                  label="Kỳ"
                  item-text="name"
                  item-value="name"
                  class="text-right"
                  hide-details=""
                  return-object
                />
              </v-col>
              <v-col cols="7">
                <v-autocomplete
                  ref="spec"
                  v-model="chiTieuModel.status"
                  :items="lstStatus"
                  label="Trạng thái"
                  item-text="name"
                  item-value="id"
                  class="text-left"
                  hide-details=""
                  return-object
                />
              </v-col>

              <!-- HSBC -->
              <v-col cols="4">
                <v-text-field
                  ref="refBank"
                  v-model="bankkModel.hsbc.name"
                  label="Bank"
                  item-text="HSBC"
                  hide-details=""
                  readonly
                  disabled="true"
                />
              </v-col>

              <v-col cols="6">
                <vuetify-money
                  ref="receiptSoTien"
                  v-model="chiTieuModel.hsbc.money"
                  label="Số Tiền"
                  class="text-right"
                  hide-details=""
                  required
                  :rules="priceRule"
                  @focus="true"
                />
              </v-col>

              <v-col
                cols="2"
                class="pt-8 pr-2"
              >
                <v-btn
                  class="mr-1 pa-0"
                  min-width="40px"
                  color="green"
                  height="25px"
                  style="padding: 1px !important"
                  @click="chotSK(chiTieuModel.hsbc)"
                >
                  <v-icon> save </v-icon>
                </v-btn>
              </v-col>

              <!-- CITI -->
              <v-col cols="4">
                <v-text-field
                  ref="refBank"
                  v-model="bankkModel.citi.name"
                  label="Bank"
                  item-text="HSBC"
                  hide-details=""
                  readonly
                  disabled="true"
                />
              </v-col>

              <v-col cols="6">
                <vuetify-money
                  ref="receiptSoTien"
                  v-model="chiTieuModel.citi.money"
                  label="Số Tiền"
                  class="text-right"
                  hide-details=""
                  required
                  :rules="priceRule"
                  @focus="true"
                />
              </v-col>

              <v-col
                cols="2"
                class="pt-8 pr-2"
              >
                <v-btn
                  class="mr-1 pa-0"
                  min-width="40px"
                  color="green"
                  height="25px"
                  style="padding: 1px !important"
                  @click="chotSK(chiTieuModel.citi)"
                >
                  <v-icon> save </v-icon>
                </v-btn>
              </v-col>

              <!-- SC BANK -->
              <v-col cols="4">
                <v-text-field
                  ref="refBank"
                  v-model="bankkModel.sc.name"
                  label="Bank"
                  item-text="HSBC"
                  hide-details=""
                  readonly
                  disabled="true"
                />
              </v-col>

              <v-col cols="6">
                <vuetify-money
                  ref="receiptSoTien"
                  v-model="chiTieuModel.sc.money"
                  label="Số Tiền"
                  class="text-right"
                  hide-details=""
                  required
                  :rules="priceRule"
                  @focus="true"
                />
              </v-col>

              <v-col
                cols="2"
                class="pt-8 pr-2"
              >
                <v-btn
                  class="mr-1 pa-0"
                  min-width="40px"
                  color="green"
                  height="25px"
                  style="padding: 1px !important"
                  @click="chotSK(chiTieuModel.sc)"
                >
                  <v-icon> save </v-icon>
                </v-btn>
              </v-col>
            </v-row>
            <v-text-field
              ref="receiptSoTien"
              v-model="chiTieuModel.ghi_chu"
              label="Ghi Chú"
              clearable
              align="right"
            />
          </v-container>
        </v-card-text>
      </v-form>
    </v-card>
  </v-dialog>
</template>

<script>
  import axios from 'axios'
  import config from '../../config/config.js'

  export default {
    layout: 'addstorage',
    components: {},
    data () {
      return {
        dialog: false,
        chiTieuModel: {
          hsbc: {
            name: 'HSBC',
            money: 0,
          },
          citi: {
            name: 'CITI BANK',
            money: 0,
          },
          sc: {
            name: 'SC BANK',
            money: 0,
          },
        },
        bankkModel: {
          hsbc: {
            name: 'HSBC',
            money: 0,
          },
          citi: {
            name: 'CITI BANK',
            money: 0,
          },
          sc: {
            name: 'SC BANK',
            money: 0,
          },
        },
        lstBank: [],
        lstKyChi: [
          '82020',
          '92020',
          '102020',
          '112020',
          '122020',
          '12021',
          '22021',
          '32021',
          '42021',
          '52021',
          '62021',
          '72021',
          '82021',
          '92021',
          '102021',
          '112021',
          '122021',
        ],
        lstStatus: [
          {
            id: 'DCHI',
            name: 'Dự Chi',
          },
          {
            id: 'CHM',
            name: 'Cho Mượn',
          },
          {
            id: 'DTT',
            name: 'Đã Tất Toán',
          },
          {
            id: 'DN',
            name: 'Dư Nợ',
          },
          {
            id: 'DTCSK',
            name: 'Đã Trả / CSK',
          },
          {
            id: 'DTN',
            name: 'Đã trả nợ',
          },
          {
            id: 'NHT',
            name: 'Nhận tiền',
          },
          {
            id: 'HTN',
            name: 'Hoàn Tiền',
          },
          {
            id: 'MNT',
            name: 'Mượn Tiền',
          },
        ],
        lstNoiDung: [
          'CHỢ',
          'GA',
          'RÁC',
          'PARTY',
          'KHÁC',
          'ĐIỆN - TP',
          'ĐIỆN - QUÊ',
          'NƯỚC - TP',
          'INTERNET - TP',
        ],
        nameRules: [(v) => !!v || 'The field is required'],
        numberRule: [(v) => !!v || 'The field is required'],
        priceRule: [(v) => !!v || 'The field is required'],
        specRule: [(v) => !!v || 'The field is required'],
        dvtRules: [(v) => !!v || 'The field is required'],
        optionsmoney: {
          locale: 'pt-BR',
          prefix: '',
          suffix: '',
          length: 11,
          precision: 0,
        },
      }
    },
    computed () {
      this.$refs.receiptSoTien.focus()
    },
    mounted () {
      this.chiTieuModel.status = 'DN'
      this.getBanks()
    // this.bankChange('HSBC')
    }, // end method
    created () {}, // end data
    methods: {
      validate () {
        let flag = true
        this.$refs.form.validate()
        this.$nextTick(function () {
          // Product name

          if (!this.$refs.receiptquatity.validate()) {
            flag = false
            this.$refs.receiptquatity.focus()
          } else if (!this.$refs.receiptSoTien.validate()) {
            flag = false
            this.$refs.receiptSoTien.focus()
          } else if (!this.$refs.receipspec.validate()) {
            flag = false
            this.$refs.receipspec.focus()
          }

          return flag
        })
      },
      async addChiTieu () {
        const seft = this
        console.log(this.chiTieuModel)
        await axios
          .post(config.API_FAMILY + '/api/insertChiTieu', this.chiTieuModel)
          .then(function (response) {
            seft.dialog = false
            // console.log('Valid store ok')
            // console.log(response.data.data)
            self.chiTieuModel = []
            seft.$emit('refeshList')
          })
      },
      refeshList () {
        this.dialog = false
        this.$emit('refeshList')
      },
      async getBanks () {
        const seft = this
        await axios
          .get(config.API_FAMILY + '/api/banks')
          .then(function (response) {
            // this.insertChitieuDialog.dialog = false;
            console.log(response.data.data)
            seft.lstBank = response.data.data
          })
      },
      bankChange ($event) {
        var bank = 'HSBC'
        console.log(new Date().getDate())
        console.log(new Date().getMonth())
        var ky_chi = this.getKyTinh(
          this.chiTieuModel.bank_code,
          new Date(),
          new Date().getDate(),
        )
        if (
          this.chiTieuModel != undefined &&
          this.chiTieuModel.bank_code != undefined &&
          this.chiTieuModel.bank_code != null
        ) {
          bank = this.chiTieuModel.bank_code
          console.log('281:' + this.chiTieuModel.bank_code)
          ky_chi = this.getKyTinh(
            this.chiTieuModel.bank_code,
            new Date(),
            new Date().getDate(),
          )
        } else {
          this.chiTieuModel.bank_code = bank
          console.log('aaaaaaaaaa:' + this.chiTieuModel.bank_code)
          ky_chi = this.getKyTinh(
            this.chiTieuModel.bank_code,
            new Date(),
            new Date().getDate(),
          )
        }
        this.chiTieuModel.ky_chi = ky_chi
        this.chiTieuModel.status = 'DN'
      },
      /** Function tra ve thang cua ky tinh toan */
      getKyTinh (sbankObj, sDate, sDay) {
        var kyTinh = ''
        var deltaMonth = 1
        var month = sDate.getMonth()
        var deltaYear = 0
        if (sbankObj != undefined && sbankObj != null) {
          var sBanName = sbankObj.name
          if (
            ((sBanName == 'HSBC' || sBanName == 'SHINHAN') && sDay + 1 >= 21) ||
            (sBanName == 'SC BANK' && sDay + 1 >= 19) ||
            (sBanName == 'CitiBank' && sDay + 1 >= 27)
          ) {
            deltaMonth = 2
          } else {
            deltaMonth = 1
          }

          if (sDate.getMonth() + deltaMonth > 12) {
            deltaYear = 1
            kyTinh = '1' + (sDate.getFullYear() + deltaYear).toString()
          } else {
            kyTinh =
              (month + deltaMonth).toString() +
              (sDate.getFullYear() + deltaYear).toString()
          }
        }
        console.log('year:' + sDate.getFullYear())
        console.log('kyTinh-' + sBanName + ':' + kyTinh)
        return kyTinh
      },

      async chotSK (saoKeObject) {
        alert('')
        console.log('chotSK')
        if (undefined != this.chiTieuModel.ky_chi) {
          const bankCode = []
          const kyChi = []
          bankCode.push(saoKeObject.name)
          kyChi.push(this.chiTieuModel.ky_chi)
          const params = {
            ghi_chu: 'Chot sao ke',
            status: 'DTCSK',
            bank_code: bankCode,
            ky_chi: kyChi,
          }
          await axios
            .post(config.API_FAMILY + '/api/updateStatusByBank', params)
            .then(function (response) {
              console.log('succuess')
              var data = response.data.data
              if (data !== undefined && data != null) {
              }
              self.getChiTieus()

            // seft.$refs.dialogConfirm.dialog = false
            })
            .catch((error) => {
              console.log(error)
            })
          console.log(saoKeObject)
          console.log(this.chiTieuModel.ky_chi)
        }
      },
    }, // end created
  } // End exxport default
</script>
<style scoped>
.text-right {
  text-align: right;
}
.text-center {
  text-align: center;
}
table tr td {
  padding: 0 8px !important;
}

.table-list table thead tr th {
  background-color: #2196f3 !important;
  color: #ffffff;
}
.table-list table {
  border-collapse: collapse !important;
  border: 1px solid gray !important;
}
</style>
